--------------------------------------------------------------------------------
USE     STD.textio.all;
LIBRARY IEEE;
USE     IEEE.STD_LOGIC_1164.all;
USE     IEEE.STD_LOGIC_MISC.all;
USE     IEEE.STD_LOGIC_TEXTIO.all;
USE     IEEE.STD_LOGIC_ARITH.all;
USE     IEEE.STD_LOGIC_UNSIGNED.all;
USE     WORK.HY57V28820HCT_PACK.all;
--------------------------------------------------------------------------------
entity E is
end E;
--------------------------------------------------------------------------------
Architecture A of E is

   signal      CLK, CKE, CSB, RASB, CASB, WEB, DQM : std_logic;
   signal      A0, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11, BA0, BA1, NC : std_logic;
   signal      DQ0, DQ1, DQ2, DQ3, DQ4, DQ5, DQ6, DQ7 : std_logic;
   signal      VDD : std_logic := '1';
   signal      VSS : std_logic := '0';
   signal      VDDQ : std_logic := '1';
   signal      VSSQ : std_logic := '0';
   constant    CLK_PERIOD : time := 30 ns;

   component HY57V28820HCT
     Generic (
         Part_Number : PART_NUM_TYPE := H     
         -- Speed Bin. (There are 6 kinds of speed bins, T6, K, H, T8, P and S.)
             );
     port (VDD1   :  in      std_logic;
           DQ0    :  inout   std_logic := 'Z';
           VDDQ3  :  in      std_logic;
           NC4    :  in      std_logic;
           DQ1    :  inout   std_logic := 'Z';
           VSSQ6  :  in      std_logic;
           NC7    :  in      std_logic;
           DQ2    :  inout   std_logic := 'Z';
           VDDQ9  :  in      std_logic;
           NC10   :  in      std_logic;
           DQ3    :  inout   std_logic := 'Z';
           VSSQ12 :  in      std_logic;
           NC13   :  in      std_logic;
           VDD14  :  in      std_logic;
           NC15   :  in      std_logic;
           WEB    :  in      std_logic;
           CASB   :  in      std_logic;
           RASB   :  in      std_logic;
           CSB    :  in      std_logic;
           BA0    :  in      std_logic;
           BA1    :  in      std_logic;
           A10    :  in      std_logic;
           A0     :  in      std_logic;
           A1     :  in      std_logic;
           A2     :  in      std_logic;
           A3     :  in      std_logic;
           VDD27  :  in      std_logic;
           VSS28  :  in      std_logic;
           A4     :  in      std_logic;
           A5     :  in      std_logic;
           A6     :  in      std_logic;
           A7     :  in      std_logic;
           A8     :  in      std_logic;
           A9     :  in      std_logic;
           A11    :  in      std_logic;
           NC36   :  in      std_logic;
           CKE    :  in      std_logic;
           CLK    :  in      std_logic;
           DQM    :  in      std_logic;
           NC40   :  in      std_logic;
           VSS41  :  in      std_logic;
           NC42   :  in      std_logic;
           VDDQ43 :  in      std_logic;
           DQ4    :  inout   std_logic := 'Z';
           NC45   :  in      std_logic;
           VSSQ46 :  in      std_logic;
           DQ5    :  inout   std_logic := 'Z';
           NC48   :  in      std_logic;
           VDDQ49 :  in      std_logic;
           DQ6    :  inout   std_logic := 'Z';
           NC51   :  in      std_logic;
           VSSQ52 :  in      std_logic;
           DQ7    :  inout   std_logic := 'Z';
           VSS54  :  in      std_logic);
   end component;

begin
--------------------------------------------------------------------------------
  UUT : HY57V28820HCT
      Generic Map (S)
      Port Map ( VDD, DQ0, VDDQ, NC, DQ1, VSSQ, NC, DQ2, VDDQ, NC,
                 DQ3, VSSQ, NC, VDD, NC, WEB, CASB, RASB, CSB, BA0,
                 BA1, A10, A0, A1, A2, A3, VDD, VSS, A4, A5,
                 A6, A7, A8, A9, A11, NC, CKE, CLK, DQM, NC,
                 VSS, NC, VDDQ, DQ4, NC, VSSQ, DQ5, NC, VDDQ, DQ6,
                 NC, VSSQ, DQ7, VSS
                );
  ------------------------------------------------
  TB : block

   begin

   STIMULUS : process

--  file testvectors : TEXT is in "vectors/autoref.dat";
--  file testvectors : TEXT is in "vectors/clksus.dat";
--  file testvectors : TEXT is in "vectors/dqmcntlcl2.dat";
--  file testvectors : TEXT is in "vectors/dqmcntlcl3.dat";
--  file testvectors : TEXT is in "vectors/easycl2.dat";
--  file testvectors : TEXT is in "vectors/easycl3.dat";
--  file testvectors : TEXT is in "vectors/int01_swt.dat";
--  file testvectors : TEXT is in "vectors/int23.dat";
--  file testvectors : TEXT is in "vectors/intlv.dat";
    file testvectors : TEXT is in "vectors/selfref_mod.dat";

    variable L : Line;
    variable CLKv, CKEv, CSBv, RASBv, CASBv, WEBv, DQMv : std_logic;
    variable A0v, A1v, A2v, A3v, A4v, A5v, A6v, A7v, A8v, A9v, A10v, A11v, BA0v, BA1v : std_logic;
    variable DQ0v, DQ1v, DQ2v, DQ3v, DQ4v, DQ5v, DQ6v, DQ7v : std_logic;
    variable sigtmp : std_logic;
    variable TEMP : Character;

    begin
      loop
        if (ENDFILE (testvectors)) then
          assert false report "Simulation finished." severity failure;exit;
        end if;
        readline (testvectors, L);
        exit when (L = NULL) or (L'length = 0);
        read (L, TEMP);
        loop
          if (TEMP = '0' or TEMP = '1') then
            CLKv := CHAR_TO_STD_LOGIC(TEMP);
            exit;
          else
            readline (testvectors, L);
            exit when (L = NULL) or (L'length = 0);
            read (L, TEMP);
          end if;
        end loop;
        read (L, CKEv);
        read (L, CSBv);
        read (L, RASBv);
        read (L, CASBv);
        read (L, WEBv);
        read (L, DQMv);
        read (L, sigtmp); -- to eliminate UDQM from vector file
        read (L, BA1v);
        read (L, BA0v);
        read (L, A11v);
        read (L, A10v);
        read (L, A9v);
        read (L, A8v);
        read (L, A7v);
        read (L, A6v);
        read (L, A5v);
        read (L, A4v);
        read (L, A3v);
        read (L, A2v);
        read (L, A1v);
        read (L, A0v);
        read (L, sigtmp); -- to eliminate DQ15 from vector file
        read (L, sigtmp); -- to eliminate DQ14 from vector file
        read (L, sigtmp); -- to eliminate DQ13 from vector file
        read (L, sigtmp); -- to eliminate DQ12 from vector file
        read (L, sigtmp); -- to eliminate DQ11 from vector file
        read (L, sigtmp); -- to eliminate DQ10 from vector file
        read (L, sigtmp); -- to eliminate DQ9 from vector file
        read (L, sigtmp); -- to eliminate DQ8 from vector file
        read (L, DQ7v);
        read (L, DQ6v);
        read (L, DQ5v);
        read (L, DQ4v);
        read (L, DQ3v);
        read (L, DQ2v);
        read (L, DQ1v);
        read (L, DQ0v);
        CLK <= CLKv;
        CKE <= CKEv;
        CSB <= CSBv;
        RASB <= RASBv;
        CASB <= CASBv;
        WEB <= WEBv;
        DQM <= DQMv;
        A0 <= A0v;
        A1 <= A1v;
        A2 <= A2v;
        A3 <= A3v;
        A4 <= A4v;
        A5 <= A5v;
        A6 <= A6v;
        A7 <= A7v;
        A8 <= A8v;
        A9 <= A9v;
        A10 <= A10v;
        A11 <= A11v;
        BA0 <= BA0v;
        BA1 <= BA1v;
        DQ0 <= DQ0v;
        DQ1 <= DQ1v;
        DQ2 <= DQ2v;
        DQ3 <= DQ3v;
        DQ4 <= DQ4v;
        DQ5 <= DQ5v;
        DQ6 <= DQ6v;
        DQ7 <= DQ7v;
        wait for CLK_PERIOD / 2;
        end loop;
    end process STIMULUS;

   end block;
  ------------------------------------------------
end A;
--------------------------------------------------------------------------------
--configuration CFG_TB_SDRAM_BEHAVIORAL of E is
--   for A
--   End for;
--end CFG_TB_SDRAM_BEHAVIORAL;
